/* *************************************************************
   RWhois Software

   Copyright (c) 1994 Scott Williamson and Mark Kosters
   Copyright (c) 1996-2000 Network Solutions, Inc.

   See the file LICENSE for conditions of use and distribution.
**************************************************************** */

#ifndef _PGP_H_
#define _PGP_H_

#include "common.h"

typedef enum
{
  PGP_SIGN,
  PGP_ENCRYPT,
  PGP_SIGN_ENCRYPT
} pgp_mode;

/* Prototype declarations */

int PGP_set_program_name PROTO(( char *progname ));
int PGP_set_key_path PROTO(( char *keypath ));

int PGP_add_key PROTO((char *key));

int PGP_verify_keyid PROTO((char *pub_ring, char *keyid));

int PGP_decrypt_msg PROTO((char *input_file, 
                           char *output_file, 
                           char *pub_ring,
                           char *keyid));

int PGP_sign_msg PROTO((char *msg_file, 
                        char *out_file, 
                        char *my_id, 
                        char *passphrase));

int PGP_encrypt_msg PROTO((char *msg_file,
                           char *out_file, 
                           char *keyid));

int PGP_sign_encrypt_msg PROTO((char *msg_file,
                                char *out_file,
                                char *keyid, 
                                char *my_id, 
                                char *passphrase));

#endif
