/* *************************************************************
   RWhois Software

   Copyright (c) 1994 Scott Williamson and Mark Kosters
   Copyright (c) 1996-1998 Network Solutions, Inc.

   See the file LICENSE for conditions of use and distribution.
**************************************************************** */

#include "common.h"

#include "client_msgs.h"
#include "defines.h"
#include "dl_list.h"
#include "fileinfo.h"
#include "fileutils.h"
#include "misc.h"
#include "mkdb_types.h"
#include "pgp_ops.h"
#include "records.h"
#include "schema.h"
#include "strutil.h"
#include "types.h"

#define X_PGP_SUCCESS 0
#define X_PGP_FAIL    1

int
main(argc, argv)
  int  argc;
  char *argv[];
{
  char *key         = NULL;
  char *newstr;
  FILE *fp;
  char *tmpfile;
  int  done         = FALSE;

  if (STR_EQ(argv[1], "on"))
  {
    if (STR_EQ(argv[2], "keyadd"))
    {
      print_ok();
      fflush(stdout);

      tmpfile = tempnam(".", "keyad");
      fp      = fopen(tmpfile, "w");

      while (!done)
      {
        if (key)
        {
          free(key);
        }

        key = xcalloc(1, sizeof(char) * 1050);
        
        gets(key);  
        fprintf(fp, "%s\n",key);

        if (strstr(key, "END"))
        {
          done = TRUE;
          fclose(fp);
        }

        if (strSTR(key, "-X-pgp off"))
        {
          return X_PGP_SUCCESS;
        }
      }
      free(key);

      newstr = xcalloc(1, sizeof(char)*100);
      gets(newstr);

      if (STRN_EQ(newstr,  "-X-pgp off keyadd", 17))
      {
        /* printf("I am here\n"); */
        key = xcalloc(1, sizeof(char) * 1050);
        fp = fopen(tmpfile, "r");
        fread(key, 1024, 1, fp);
        fclose(fp);
        if (!(PGP_add_key(key)))
        {
          print_error(CORRUPT_DATA, "");
          unlink(tmpfile);
          return X_PGP_FAIL;
        }
        /* print_ok(); */
       
        unlink(tmpfile);
        return X_PGP_SUCCESS;
      }
      else
      {
        print_error(UNIDENT_ERROR, "%s", newstr);
        unlink(tmpfile);
        return X_PGP_FAIL;
      }
    }
    else 
    {
      print_error(UNIDENT_ERROR, "");
      return X_PGP_FAIL;
    }
  } 
  
  print_error(UNIDENT_ERROR, "");
  return X_PGP_FAIL;
}
